static char *sccsid = "@(#) lib/exits/oltp/pc/os2/amqzsc72.c, lqm, p000, p000-L951027 	1.3 95/10/20 10:10:21";
/*********************************************************************/
/*                                                                   */
/* Module Name: amqzsc72.c                                           */
/*                                                                   */
/* Description: MQSeries for OS/2 exit program for CICS/2            */
/*              User Exit 17 - Task Abend                            */
/*                                                                   */
/*  Statement:     Licensed Materials - Property of IBM              */                      
/*                                                                   */      
/*                 84H2000, 5765-B73                                 */            
/*                 84H2001, 5639-B42                                 */            
/*                 84H2002, 5765-B74                                 */            
/*                 84H2003, 5765-B75                                 */            
/*                 84H2004, 5639-B43                                 */            
/*                 (C) Copyright IBM Corp. 1994, 1997                */  
/*********************************************************************/
/*                                                                   */
/* Function:                                                         */
/*                                                                   */
/* amqzsc72.c is the Task Abend Exit program for CICS/2.             */
/* It is based on the CICS/2 sample code FAAEXP17.C, whose original  */
/* header and copyright is included below.                           */
/*                                                                   */
/* amqzsc72.c contains the following functions:                      */
/*  FAAEXP17             CICS/2 User entry point 17                  */
/*                                                                   */
/*********************************************************************/

/***********************************************************************/
/*                                                                     */
/* MODULE NAME        FAAEXP17.C                                       */
/*                                                                     */
/* DESCRIPTIVE NAME   User exit - 17. Transaction Abend Exit           */
/*                                                                     */
/* Statement:         Licensed Materials - Property of IBM             */
/*                                                                     */
/*                    53G3861,53G3862                                  */
/*                    (c) Copyright IBM Corp. 1988, 1993.              */
/*                                                                     */
/*                    See Copyright Instructions.                      */
/*                                                                     */
/*                    All rights reserved.                             */
/*                                                                     */
/*                    U.S. Government Users Restricted Rights - use,   */
/*                    duplication or disclosure restricted by GSA      */
/*                    ADP Schedule Contract with IBM Corp.             */
/*                                                                     */
/* Status:            Version 2 Release 0                              */
/*                                                                     */
/*  NOTES :-                                                           */
/*    DEPENDENCIES = None                                              */
/*                   None                                              */
/*    RESTRICTIONS = none                                              */
/*    MODULE TYPE  = Program                                           */
/*    PROCESSOR    = PS/2 and PC                                       */
/*                                                                     */
/***********************************************************************/
/*                                                                     */
/*  FUNCTION:                                                          */
/*       To enable the user to perform any non CICS API calls at task  */
/*       abend time.  The parameters passed to this exit program       */
/*       are defined in the header FAAEXH17.H                          */
/*                                                                     */
/*                                                                     */
/***********************************************************************/

/*********************************************************************/
/* Includes                                                          */
/*********************************************************************/

/*********************************************************************/
/* Select compiler specific header files                             */
/*********************************************************************/

/*********************************************************************/
/* Select CICS/2 header files                                        */
/*********************************************************************/

#include <faaexh17.h>

/*********************************************************************/
/* Select MQI header file                                            */
/*********************************************************************/

#include <cmqc.h>

/*********************************************************************/
/* Define the MQ externals for this function                         */
/*********************************************************************/

extern void FAAFN1616 AMQ1PHASETASKABEND   ( void );

/*********************************************************************/
/* Data defined in this module                                       */
/*********************************************************************/

static char dummy; /* To maintain compatability with the Au icc opt. */
                   /* Not required when other static data exists     */

/*********************************************************************/
/* Local function declarations                                       */
/*********************************************************************/

/*********************************************************************/
/* Function Definitions                                              */
/*********************************************************************/

/*********************************************************************/
/*                                                                   */
/* Function Name:  FAAEXP17                                          */
/*                                                                   */
/* Description: CICS/2 User Exit 17 - Task abend.                    */
/*                                                                   */
/*********************************************************************/
/* Following text will be included in the Service Reference Manual . */
/* Ensure that the content is correct and up-to-date.                */
/* All updates should be made in mixed case.                         */
/*                                                                   */
/* Function:                                                         */
/*                                                                   */
/*  FAAEXP17 is called by CICS/2 whenever a user task abends.        */
/*  Since the task may still be connected, and have Open Queues      */
/*  we should perform any MQDISC processing that should have been    */
/*  performed by the CICS task before it terminated. We must         */
/*  rollback any CICS transaction that is active. MQ is notified     */
/*  as to the fact that the task has abended by a call to the        */
/*  function AMQ1PHASETASKABEND, in library MQMCICS.                 */
/*                                                                   */
/* Input Parameters:  pExit17Input (faap_exit_17_t)                  */
/*                     - Exit 17 parameters                          */
/*                                                                   */
/* Output Parameters: None                                           */
/*                                                                   */
/* InOut Parameters:  None                                           */
/*                                                                   */
/* Returns:           * indicates FFST has been performed            */
/*     0                          - Success.                         */
/*                                                                   */
/* Exit Normal:       See Above                                      */
/*                                                                   */
/* Exit Error:        See Above                                      */
/*                                                                   */
/* End of text to be included in SRM                                 */
/*********************************************************************/
/*                                                                   */
/* Notes:                                                            */
/*   Restrictions: None                                              */
/*                                                                   */
/*********************************************************************/

faaret_t FAAEXPENTRY FAAEXP17(faap_exit_17_t pExit17Input)
{
faaret_t rc = 0;

  /*******************************************************************/
  /* Call MQ to register the task abend                              */
  /*******************************************************************/
  AMQ1PHASETASKABEND();

  /*******************************************************************/
  /* Return from function                                            */
  /*******************************************************************/
  return rc;

} /* End function FAAEXP17                                           */

/*********************************************************************/
/*                                                                   */
/* End of amqzsc72.c                                                 */
/*                                                                   */
/*********************************************************************/
