/*********************************************************************/
/*                                                                   */
/* Module Name: AMQODQ0M.C                                           */
/*                                                                   */
/* Description: RUNMQDLQ Parser: YACC                                */
/*                                                                   */
/* Statement:     Licensed Materials - Property of IBM               */
/*                                                                   */
/*                5765-115 5621-390 (C) Copyright IBM Corp. 1994     */
/*                                                                   */
/*                U.S. Government Users Restricted Rights - use,     */
/*                duplication or disclosure restricted by GSA ADP    */
/*                Schedule Contract with IBM Corp.                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING   */
/*   This file was generated by running YACC against the source file */
/*                                                                   */
/*   AMQODQ0M.Y                                                      */
/*                                                                   */
/*   Updates should be made to the above source file and NOT to      */
/*   this file.                                                      */
/* WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING   */
/*                                                                   */
/*********************************************************************/
#include <string.h>
#include <stdio.h>
#include <cmqc.h>
#include <amqodqha.h>

#if defined(AMQ_NT)
   #pragma warning(disable:4129)
   #pragma warning(disable:4102)
#endif

static odqPattern_t *pPat;

extern int odqLineNo;


/*--------------------------------------------------------------------*/
/* F U N C T I O N     P R O T O T Y P E S                            */
/*--------------------------------------------------------------------*/
static odqResp odqAddLine(void);

static odqResp odqPrepareTemplate(void);

static odqResp odqAddParm(odqKeyword key, odqParm Value);

static odqResp odqUseDefault(odqKeyword key);

int            yyparse (void);
void           yyerror (char * msg);
int            yylex   (void);

#undef FUNCTION
#define FUNCTION odqtodqyyparse


typedef union  {
         odqParm o;
       } YYSTYPE;
#define ACTION 257
#define APPLIDAT 258
#define APPLTYPE 259
#define APPLNAME 260
#define DESTQ 261
#define DESTQM 262
#define FEEDBACK 263
#define FORMAT 264
#define FWDQ 265
#define FWDQM 266
#define HEADER 267
#define MSGTYPE 268
#define PERSIST 269
#define REASON 270
#define REPLYQ 271
#define REPLYQM 272
#define RETRY 273
#define USERID 274
#define LBRACKET 275
#define RBRACKET 276
#define UNEXPECTED 277
#define INTEGER 278
#define NEWLINE 279
#define WSTRING 280
#define STRING 281
#define INPUTQM 282
#define INPUTQ 283
#define WAIT 284
#define RETRYINT 285
#define PUTAUT 286
#define DEFAULT 287
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval;
YYSTYPE yyval;
typedef int YYTABELEM;
#define YYERRCODE 256


extern FILE *yyin ;

#undef FUNCTION
#define FUNCTION odqtodqProcessStdin

/*********************************************************************/
/*                                                                   */
/* Function: odqProcessStdin                                         */
/*                                                                   */
/* Description: Parse the input rule table                           */
/*                                                                   */
/* Intended Function: This parses the input rule table converting    */
/*                    the rules from a text based format to a        */
/*                    structure which is easier for the DLQ handler  */
/*                    to use.                                        */
/*                                                                   */
/* Input Parameters: none (stdin)                                    */
/*                                                                   */
/* Output Parameters: none ( list of rules anchored in odqGlobal)    */
/*                                                                   */
/* Returns:                                                          */
/*********************************************************************/
odqResp odqProcessStdin ( void )
{
 odqResp rc=odq_Ok ;

 odq_fnc_entry( FUNCTION ) ;
/*--------------------------------------------------------------------*/
/* Build an empty template for the parser to fill in.                 */
/*--------------------------------------------------------------------*/
 rc = odqPrepareTemplate();
 if ( odq_Error > rc )
 {
   /*-----------------------------------------------------------------*/
   /* Default the RetryInt in the first template.                     */
   /*-----------------------------------------------------------------*/
   pPat->Parm[RetryInt].i = 60 ;
   yyin = stdin ;
   while(!feof(yyin))
   {
     yyparse();
   }
 }
/*--------------------------------------------------------------------*/
/* We allow the parser to continue after the first error is detected  */
/* so that all of the errors are diagnosed on a single pass.          */
/* After the parser completes we terminate if any errors were         */
/* detected.                                                          */
/*--------------------------------------------------------------------*/
 if ( 0!= odqGlobal.odqInputErrorCount )
 {
   rc = odq_InvalidInput ;
   odqFFDC( /*IN*/
              FUNCTION,
              rc,
              odqGlobal.odqInputErrorCount,
              0,
              NULL
            /*OUT*/
          ) ;
 }
 else
 {
   /*-----------------------------------------------------------------*/
   /* It's not meaningful for the DLQ handler to continue if there    */
   /* are no templates as the default action is to ignore messages.   */
   /*-----------------------------------------------------------------*/
   if ( NULL == odqGlobal.odqPatternHead)
   {
     rc = odq_NoValidInput ;
     odqFFDC( /*IN*/
                FUNCTION,
                rc,
                0,
                0,
                NULL
              /*OUT*/
            ) ;
   }
 }
 odq_fnc_retcode( FUNCTION, rc ) ;
 return rc ;
}





#undef  FUNCTION
#define FUNCTION odqtodqPrepareTemplate

/*********************************************************************/
/*                                                                   */
/* Function: odqPrepareTemplate                                      */
/*                                                                   */
/* Description: Build a blank rule template                          */
/*                                                                   */
/* Intended Function: This function builds a blank rule template     */
/*                    which can then be filled in by the parser.     */
/*                    The static global pPat is set to point to      */
/*                    the blank template obtained.                   */
/*                                                                   */
/* Input Parameters: none                                            */
/*                                                                   */
/* Output Parameters: none                                           */
/*                                                                   */
/* Returns:                                                          */
/*********************************************************************/
/*--------------------------------------------------------------------*/
/* odqPrepareTemplate: setup a blank template for the parser to fill  */
/*                     in.                                            */
/*--------------------------------------------------------------------*/
static odqResp odqPrepareTemplate(void)
{
 odqResp rc=odq_Ok ;
 odq_fnc_entry( FUNCTION ) ;
 /*------------------------------------------------------------------*/
 /* Get some storage in which to keep our representation of the      */
 /* pattern line.                                                    */
 /*------------------------------------------------------------------*/
 rc = odqGetMem(sizeof(*pPat)+
                    LastKeyword*sizeof(odqParmSpec_t),
               "PatternLine",
               (void **)&pPat);
 if (odq_Error > rc )
 {
   pPat->ParmSpecified = (odqParmSpec_t*)&(pPat->Parm[LastKeyword].i);
   memset( pPat->ParmSpecified, 0, LastKeyword*sizeof(odqParmSpec_t) );
   pPat->next = NULL ;
 }
 else
 {
   odqGlobal.odqInputErrorCount ++ ;
 }
 odq_fnc_retcode( FUNCTION, rc ) ;
 return rc ;
}

#undef  FUNCTION
#define FUNCTION odqtodqAddParm

/*********************************************************************/
/*                                                                   */
/* Function: odqAddParm                                              */
/*                                                                   */
/* Description: Add a parameter to the current rule template         */
/*                                                                   */
/* Intended Function: This function performs duplicate and size      */
/*                    checking on parameters, and if the parameters  */
/*                    meet the relevant contraints add the parameter */
/*                    to the current rule template.                  */
/*                                                                   */
/* Input Parameters: pECAnchor                                       */
/*                                                                   */
/* Output Parameters: none                                           */
/*                                                                   */
/* Returns:                                                          */
/*********************************************************************/
/*--------------------------------------------------------------------*/
/* odqAddParm: Add a parameter to the current template.               */
/*--------------------------------------------------------------------*/
static odqResp odqAddParm(odqKeyword key, odqParm Value)
{
 odqResp rc=odq_Ok ;
 int i,j ;
 odq_fnc_entry( FUNCTION ) ;
 /*--------------------------------------------------------------*/
 /* Any environment specifications must be in the first input    */
 /* line to runmqdlq. As soon as we see a parameter that is not  */
 /* an environment specification we can be sure that no          */
 /* further environment specification will occur.                */
 /* If we've not already connected to the queue manager then     */
 /* perform the connect now. We want to connect as early as      */
 /* possible so that errors are associated with the correct      */
 /* queue manager.                                               */
 /*--------------------------------------------------------------*/
 if ( InputQ > key &&
      0 == odqGlobal.odqConnectAttempted )
 {
    rc = odqConnectQmgr ("") ;
    /*-----------------------------------------------------------*/
    /* If the connect fails then we choose to soldier on and     */
    /* parse the rest of the input file. Once the input file     */
    /* has been processed we will terminate without any further  */
    /* action.                                                   */
    /*-----------------------------------------------------------*/
    if (odq_Error <= rc )
    {
      odqGlobal.odqInputErrorCount ++ ;
    }
 }
 /*-------------------------------------------------------------------*/
 /* if we've already seen this parameter then flag it as a duplicate. */
 /*-------------------------------------------------------------------*/
 if (*(pPat->ParmSpecified+key) != NotSpecified)
 {
    odqFFDC( /*IN*/
               FUNCTION,
               odq_DuplicateKeyword,
               odqLineNo,
               0,
               odqParmAttrs[key].keyword,
               strlen(odqParmAttrs[key].keyword),
               "Keyword",
               NULL
             /*OUT*/
           ) ;
     rc = odq_DuplicateKeyword ;
     odqGlobal.odqInputErrorCount ++ ;
 }
 else
 {
   *(pPat->ParmSpecified+key) = Specified ;
   /*-----------------------------------------------------------*/
   /* Count the minimum number of characters required to match  */
   /* the pattern. If this number exceeds the maximum length of */
   /* the field then it's not possible for this pattern to be   */
   /* matched.                                                  */
   /*-----------------------------------------------------------*/
   switch(odqParmAttrs[key].format)
   {
     /*---------------------------------------------------------*/
     /* String including wildcards                              */
     /*---------------------------------------------------------*/
     case 'w':
       for( i = 0, j=0 ;
            Value.s[i] != 0 ;
            i++ )
       {
         if( odqANY_SUBSTRING !=  Value.s[i] )
         {
            j++ ;
         }
       }
       break;
     /*---------------------------------------------------------*/
     /* String excluding wildcards                              */
     /*---------------------------------------------------------*/
     case 's':
       for( j = 0;
            Value.s[j] != 0 ;
            j++ );
       break;
     /*---------------------------------------------------------*/
     /* integer                                                 */
     /*---------------------------------------------------------*/
     case 'd':
       j = sizeof( int ) ;
       break ;
   }
   if( odqParmAttrs[key].maxlen < j )
   {
     odqFFDC( /*IN*/
                  FUNCTION,
                  odq_InvalidFieldLen,
                  odqLineNo,
                  0,
                  odqParmAttrs[key].keyword,
                  strlen(odqParmAttrs[key].keyword),
                  "Keyword",
                  NULL
                /*OUT*/
              ) ;
        rc = odq_InvalidFieldLen ;
        odqGlobal.odqInputErrorCount ++ ;
   }
   else
   {
     pPat->Parm[key] = Value;
   }
 }
 odq_fnc_retcode( FUNCTION, rc ) ;
 return rc ;
}
#undef  FUNCTION
#define FUNCTION odqtodqUseDefault

/*********************************************************************/
/*                                                                   */
/* Function: odqAddParm                                              */
/*                                                                   */
/* Description: Add a parameter to the current rule template         */
/*                                                                   */
/* Intended Function: This function performs duplicate and size      */
/*                    checking on parameters, and if the parameters  */
/*                    meet the relevant contraints add the parameter */
/*                    to the current rule template.                  */
/*                                                                   */
/* Input Parameters: pECAnchor                                       */
/*                                                                   */
/* Output Parameters: none                                           */
/*                                                                   */
/* Returns:                                                          */
/*********************************************************************/
static odqResp odqUseDefault(odqKeyword key)
{
 odqResp rc=odq_Ok ;
 odq_fnc_entry( FUNCTION ) ;
 /*-------------------------------------------------------------------*/
 /* if we've already seen this parameter then flag it as a duplicate. */
 /*-------------------------------------------------------------------*/
 if (*(pPat->ParmSpecified+key) != NotSpecified)
 {
    odqFFDC( /*IN*/
               FUNCTION,
               odq_DuplicateKeyword,
               odqLineNo,
               0,
               odqParmAttrs[key].keyword,
               strlen(odqParmAttrs[key].keyword),
               "Keyword",
               NULL
             /*OUT*/
           ) ;
     rc = odq_DuplicateKeyword ;
     odqGlobal.odqInputErrorCount ++ ;
 }
 else
 {
   *(pPat->ParmSpecified+key) = ExplicitlyDefaulted ;
 }
 odq_fnc_retcode( FUNCTION, rc ) ;
 return rc ;
}


#undef  FUNCTION
#define FUNCTION odqtodqAddLine
/*--------------------------------------------------------------------*/
/* odqAddLine: Add the current rule to the list of rules              */
/*--------------------------------------------------------------------*/
static odqResp odqAddLine(void)
{
 odqResp rc=odq_Ok ;

 odq_fnc_entry( FUNCTION ) ;
 /*-------------------------------------------------------------------*/
 /* Set up some defaults for 'optional fields'                        */
 /*-------------------------------------------------------------------*/
 if ( NotSpecified == *(pPat->ParmSpecified+Retry) )
 {
   pPat->Parm[Retry].i = 1 ;
 }
 if ( NotSpecified == *(pPat->ParmSpecified+Header) )
 {
   pPat->Parm[Header].i = 1 ;
 }
 if ( NotSpecified == *(pPat->ParmSpecified+PutAut) )
 {
   pPat->Parm[PutAut].i = 0 ;
 }

 /*-------------------------------------------------------------------*/
 /* Save the line number of the pattern for use in debugging.         */
 /*-------------------------------------------------------------------*/
 pPat->LineNo = odqLineNo - 1;

 /*-------------------------------------------------------------------*/
 /* Detect invalid combinations of parameters.                        */
 /*-------------------------------------------------------------------*/
 if (
       (*(pPat->ParmSpecified+Action) != Specified)
       |
       (pPat->Parm[Action].i == odqFORWARD &&
        *(pPat->ParmSpecified+ForwardQ) != Specified)
       |
       (pPat->Parm[Action].i != odqFORWARD &&
        *(pPat->ParmSpecified+ForwardQMgr) != NotSpecified)
       |
       (pPat->Parm[Action].i != odqFORWARD &&
        *(pPat->ParmSpecified+Header) != NotSpecified)
    )
 {
    odqFFDC( /*IN*/
               FUNCTION,
               odq_InvalidInputComb,
               odqLineNo - 1,
               0,
               NULL
             /*OUT*/
           ) ;
     rc = odq_InvalidInputComb ;
     odqGlobal.odqInputErrorCount ++ ;
 }

 /*-------------------------------------------------------------------*/
 /* Add the current pattern into the chain of patterns.               */
 /*-------------------------------------------------------------------*/
 if ( odq_Error > rc )
 {
   pPat->next = NULL ;
   if ( odqGlobal.odqPatternHead == NULL )
   {
      odqGlobal.odqPatternHead = pPat ;
   }
   else
   {
     odqPattern_t *lPattern ;
     for( lPattern = odqGlobal.odqPatternHead ;
          lPattern->next != NULL ;
          lPattern = lPattern->next );
     lPattern -> next = pPat ;
   }
 }

 /*-------------------------------------------------------------------*/
 /* Prepare the next template for the parser to complete.             */
 /*-------------------------------------------------------------------*/
 rc = odqPrepareTemplate();
 odq_fnc_retcode( FUNCTION, rc ) ;
 return rc ;
}
#undef FUNCTION
#define FUNCTION odqtodqyyparse
static YYTABELEM yyexca[] = {
    -1,     1,
     0,    -1,
    -2,     0,
};

#define YYNPROD 48
#define YYLAST 144
static const YYTABELEM yyact[144] = {
    12,    30,    22,    25,    23,    18,    19,    28,    17,    34,
    35,    31,    27,    29,    26,    20,    21,    32,    24,    76,
    78,    43,    45,     8,    77,    83,    14,    13,    16,    15,
    33,    12,    30,    22,    25,    23,    18,    19,    28,    17,
    34,    35,    31,    27,    29,    26,    20,    21,    32,    24,
    77,    48,    38,    82,     8,    14,    13,    16,    15,    79,
    81,    33,    30,    22,    25,    23,    18,    19,    28,    17,
    34,    35,    31,    27,    29,    26,    20,    21,    32,    24,
    80,    61,    51,    47,    40,     4,    44,    11,    36,    10,
     6,    33,     9,     5,    42,     2,    41,    60,    39,    37,
    49,    46,     7,     3,     1,     0,     0,     0,     0,    59,
    62,    64,    66,    68,    70,    71,    72,    73,    50,     0,
     0,    74,    75,    36,    63,    65,    67,    69,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    52,    53,    54,
    55,    56,    57,    58
};

static const YYTABELEM yypact[84] = {
  -256, -1000,  -225,  -225, -1000,  -227,  -195, -1000, -1000, -1000,
 -1000, -1000,  -258,  -253,  -253,  -224,  -224,  -193,  -193,  -193,
  -193,  -193,  -193,  -193,  -193,  -194,  -194,  -194,  -194,  -194,
  -224,  -224,  -224,  -224,  -253,  -253, -1000,  -225, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,  -262, -1000, -1000,  -254, -1000,
 -1000,  -260, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,  -228, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000,  -196,  -216,  -223,  -251,
 -1000, -1000, -1000, -1000
};

static const YYTABELEM yypgo[15] = {
     0,   104,    83,    86,   118,    95,   103,   102,    93,    92,
    85,    90,    89,    87,    97
};

static const YYTABELEM yyr1[48] = {
     0,     1,     1,     7,     6,     8,     8,     9,     9,     9,
     9,     5,     5,    10,    10,    10,    11,    11,    11,    11,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    13,    13,
    13,    13,    13,    13,     2,    14,     4,     3
};

static const YYTABELEM yyr2[48] = {
     0,     1,     2,     2,     2,     1,     2,     2,     2,     2,
     2,     1,     2,     2,     1,     1,     1,     1,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     3,     3,     3,     3
};

static const YYTABELEM yychk[84] = {
 -1000,    -1,    -5,    -6,   -10,    -8,   -11,    -7,   279,    -9,
   -12,   -13,   256,   283,   282,   285,   284,   264,   261,   262,
   271,   272,   258,   260,   274,   259,   270,   268,   263,   269,
   257,   267,   273,   286,   265,   266,   -10,    -5,   279,    -9,
   279,   -12,   -13,   279,    -3,   275,    -3,    -2,   275,    -2,
    -4,   275,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -2,
   -14,   275,    -2,   -14,    -2,   -14,    -2,   -14,    -2,   -14,
    -2,    -2,    -2,    -2,    -3,    -3,   281,   278,   280,   287,
   276,   276,   276,   276
};

static const YYTABELEM yydef[84] = {
     0,    -2,     1,     0,    11,     0,     0,    14,    15,     5,
    16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    12,     2,     4,     6,
    13,    18,    19,     3,     7,     0,     8,     9,     0,    10,
    20,     0,    21,    22,    23,    24,    25,    26,    27,    28,
    33,     0,    29,    34,    30,    35,    31,    36,    32,    37,
    38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
    47,    44,    46,    45
};

/*----------------------------------------------------------------------------
 * This is a parser generated by JQYACC, using file YACC.SKE
 * by Dr. John Q. Walker II (johnq@ralvm6.vnet.ibm.com), May 2, 1992
 *--------------------------------------------------------------------------*/

#define YACC_PARSER

#ifdef YYDEBUG
    #ifndef YYDEBUG_DECLARED
        #define YYDEBUG_DECLARED
        static int yydebug = 1;   /* set this to 1 when you are debugging */
        #define YY_D(x)           if(yydebug) {x;} else
        #include <ctype.h>
    #endif
#else
    #ifndef YY_D
        #define YY_D(x)
    #endif
#endif

#define YYFLAG   (-1000)
#define YYERROR  goto yyerrlab
#define YYACCEPT return(0)
#define YYABORT  return(1)

/* Global variables used by the parser */

YYSTYPE yyv[YYMAXDEPTH];        /* value stack */
YYSTYPE *yypv;                  /* top of value stack */
YYSTYPE *yypvt;                 /* $n: top of value stack for $vars */

YYTABELEM yys[YYMAXDEPTH];      /* state stack */
YYTABELEM *yyps;                /* top of state stack */
YYTABELEM yystate;              /* current state */

int yynerrs;                    /* number of errors */
int yyerrflag;                  /* error recovery flag */
int yychar;                     /* current input token nbr, 0 means EOF */


/* Parser for YACC output */
int yyparse(void) {

    YYTABELEM yyj;              /* temporary variable */
    YYTABELEM yym;              /* temporary variable: current production */
    YYTABELEM yyn;              /* temporary variable: production */
    YYTABELEM *yyxi;            /* index through exception table */


    /* Initialize externals - yyparse may be called more than once */
    yystate   = 0;              /* the initial state is zero */
    yynerrs   = 0;              /* no errors yet */
    yyerrflag = 0;              /* error recovery flag, initial setting */
    yychar    = -1;             /* when < 0, get another; when 0, EOF */
    yyps      = &yys[-1];       /* point before the first state element */
    yypv      = &yyv[-1];       /* point before the first value element */

yystack:                        /* put a state & value onto the stack */

    YY_D( printf("state  %5d, ", yystate); );
    YY_D( if (isgraph(yychar)) printf("char: \"%c\"\n", yychar);
          else printf("char: %#2.2x\n", (unsigned char)yychar); );

    if (++yyps < &yys[YYMAXDEPTH]) {
        *yyps = yystate;        /* save the current state at the top */
        ++yypv;                 /* move to the next value stack position */
        *yypv = yyval;          /* save the current value at the top */
    }
    else {
        yyerror("YACC stack overflow; consider increasing \"YYMAXDEPTH\"");
        YYABORT;
    }

yynewstate:

    if ((yyn = yypact[yystate]) > YYFLAG) {
        if (yychar < 0)         /* OK to get another? */
            if ((yychar = yylex()) < 0) /* read from lexical analyzer */
                yychar = 0;     /* EOF reached */
        if (((yyn += yychar) >= 0) && (yyn < YYLAST)) {
            if (yychk[yyn = yyact[yyn]] == yychar) { /* valid shift */
                yychar  = -1;   /* get another lexical analyzer value */
                yyval   = yylval;
                yystate = yyn;
                if (yyerrflag > 0)
                    --yyerrflag;
                goto yystack;   /* put a state & value onto the stack */
            }
        }
    }

    /* default state action */
    if ((yyn = yydef[yystate]) == -2) {
        if (yychar < 0)         /* OK to get another? */
            if ((yychar = yylex()) < 0) /* read from lexical analyzer */
                yychar = 0;     /* EOF reached */

        /* look through the exception table */
        for (yyxi = yyexca; (*yyxi != -1) || (yyxi[1] != yystate); yyxi += 2);
            /* VOID */

        while (*(yyxi += 2) >= 0)
            if (*yyxi == yychar)
                break;
        if ((yyn = yyxi[1]) < 0)
            YYACCEPT;
    }

    if (yyn == 0) {             /* was an error detected? */
        /* error found; attempt to resume parsing */
        switch (yyerrflag) {
            case 0:             /* a new error */
                yyerror("syntax error");
yyerrlab:
                ++yynerrs;      /* another error encountered */

            case 1:
            case 2:             /* incompletely recovered error, try again */

                yyerrflag = 3;

                /* find a state where "error" is a legal shift action */

                for ( ; (yyps >= yys); yyps--, yypv--) {
                    yyn = yypact[*yyps] + YYERRCODE;
                    if ((yyn >= 0) && (yyn < YYLAST) &&
                        (yychk[yyact[yyn]] == YYERRCODE)) {
                        yystate = yyact[yyn]; /* simulate shift of "error"  */
                        goto yystack; /* put a state & value onto the stack */
                    }
                    yyn = yypact[*yyps];

                    /* the current yyps has no shift on "error", pop stack  */

                    YY_D( printf("error recovery pops state %d, uncovers %d\n",
                          *yyps, yyps[-1]) );
                }

                /* There is no state on the stack with an error shift ... */
                YYABORT;

            case 3:         /* no shift yet; consume an input character */

                YY_D( printf("error recovery discards "); );
                YY_D( if (isgraph(yychar)) printf("char: \"%c\"\n", yychar);
                      else printf("char: %#2.2x\n", (unsigned char)yychar); );

                if (yychar != 0) {      /* reached EOF? */
                    yychar = -1;        /* get another lex value */
                    goto yynewstate;    /* try again in the same state */
                }
                else YYABORT;           /* EOF reached */
        }  /* end of the switch (yyerrflag) */
    }
    /* reduction by production yyn */

    YY_D( printf("reduce %5d\n", (int)yyn) );

    yyps -= yyr2[yyn];
    yypvt = yypv;
    yypv -= yyr2[yyn];
    yyval = yypv[1];

    /* consult goto table to find next state */
    yym   = yyn;
    yyn   = (YYTABELEM)yyr1[yyn];
    yyj   = yypgo[yyn] + *yyps + 1;
    if ((yyj >= YYLAST) || (yychk[yystate = yyact[yyj]] != -yyn))
        yystate = yyact[yypgo[yyn]];

    switch (yym) {
        
case 7:{odqAddParm(InputQ, yypvt[-0].o); } break;
case 8:{
                         odqResp rc;
                         rc = odqAddParm(InputQM, yypvt[-0].o);
                         if( odq_Ok == rc)
                         {
                           rc = odqConnectQmgr ( pPat->Parm[InputQM].s ) ;
                           if( odq_Error <= rc )
                           {
                              odqGlobal.odqInputErrorCount ++ ;
                           }
                         }
                       } break;
case 9:{odqAddParm(RetryInt, yypvt[-0].o); } break;
case 10:{
                          if( yypvt[-0].o.i > -2 && yypvt[-0].o.i <= 999999)
                          {
                            odqAddParm(Wait,yypvt[-0].o);
                          }
                          else
                          {
                            odqFFDC( /*IN*/
                                       FUNCTION,
                                       odq_ValueOutOfRange,
                                       odqLineNo,
                                       yypvt[-0].o.i,
                                       odqParmAttrs[Wait].keyword,
                                       strlen(odqParmAttrs[Wait].keyword),
                                       "Keyword",
                                       NULL
                                     /*OUT*/
                                   ) ;
                            odqGlobal.odqInputErrorCount ++ ;
                          }
                        } break;
case 13:{
                                             odqResp rc;
                                             rc=odqAddLine();
                                             if( odq_Error <= rc )
                                             {
                                               YYABORT;
                                             }
                                           } break;
case 15:{
/*--------------------------------------------------------------------*/
/* If we detect a syntax error then a 'unexpected' token will be      */
/* returned. When we see an unexpected end of line we check to see    */
/* if we're part way through a rule. If so then we must create a      */
/* new template.                                                      */
/*                                                                    */
/* Note: we only check the 'normal' parameters and not the environment*/
/*       parms as we don't want to add a rule with only env parms.    */
/*--------------------------------------------------------------------*/
                                 odqResp rc;
                                 int i ;
                                 for( i = FirstKeyword;
                                      i < InputQ &&
                                      (*(pPat->ParmSpecified+i)
                                              == NotSpecified);
                                      i ++ );
                                  if (i < InputQ )
                                  {
                                    rc=odqAddLine();
                                    if( odq_Error <= rc )
                                    {
                                      YYABORT;
                                    }
                                  }
                               } break;
case 20:{odqAddParm(Format,yypvt[-0].o);} break;
case 21:{odqAddParm(DestQName,yypvt[-0].o);} break;
case 22:{odqAddParm(DestQMgrName,yypvt[-0].o);} break;
case 23:{odqAddParm(ReplyToQ,yypvt[-0].o);} break;
case 24:{odqAddParm(ReplyToQMgr,yypvt[-0].o);} break;
case 25:{odqAddParm(ApplIdentityData,yypvt[-0].o);} break;
case 26:{odqAddParm(PutApplName,yypvt[-0].o);} break;
case 27:{odqAddParm(UserIdentifier,yypvt[-0].o);} break;
case 28:{odqAddParm(PutApplType,yypvt[-0].o);} break;
case 29:{odqAddParm(Reason,yypvt[-0].o);} break;
case 30:{odqAddParm(MsgType,yypvt[-0].o);} break;
case 31:{odqAddParm(Feedback,yypvt[-0].o);} break;
case 32:{odqAddParm(Persistence,yypvt[-0].o);} break;
case 33:{odqUseDefault(PutApplType);} break;
case 34:{odqUseDefault(Reason);} break;
case 35:{odqUseDefault(MsgType);} break;
case 36:{odqUseDefault(Feedback);} break;
case 37:{odqUseDefault(Persistence);} break;
case 38:{
                        odqAddParm(Action,yypvt[-0].o);
                      } break;
case 39:{odqAddParm(Header,yypvt[-0].o);} break;
case 40:{
                        if( yypvt[-0].o.i > 0 )
                        {
                          odqAddParm(Retry,yypvt[-0].o);
                        }
                        else
                        {
                          odqFFDC( /*IN*/
                                     FUNCTION,
                                     odq_ValueOutOfRange,
                                     odqLineNo,
                                     yypvt[-0].o.i,
                                     odqParmAttrs[Retry].keyword,
                                     strlen(odqParmAttrs[Retry].keyword),
                                     "Keyword",
                                     NULL
                                   /*OUT*/
                                 ) ;
                          odqGlobal.odqInputErrorCount ++ ;
                        }
                      } break;
case 41:{odqAddParm(PutAut,yypvt[-0].o);} break;
case 42:{odqAddParm(ForwardQ,yypvt[-0].o);} break;
case 43:{odqAddParm(ForwardQMgr,yypvt[-0].o);} break;
case 44:{ yyval.o = yypvt[-1].o;} break;
case 46:{ yyval.o = yypvt[-1].o;} break;
case 47:{ yyval.o = yypvt[-1].o;} break;
    } /* end of switch (yym) */

    goto yystack; /* put a state & value onto the stack */
} /* end of yyparse() */
