#
# Name:          XASWITI.MAK
#
# Description:   Windows NT makefile for DB2 XA switch file. Note this
#                is the makefile for use with the IBM VisualAge for C++
#                compiler, if you use Microsofts Visual C++, use the
#                makefile called XASWIT.MAK.
#
# Statement:     Licensed Materials - Property of IBM
#                04L1830, 5639-B43
#                (C) Copyright IBM Corp. 1998
#
#
# To make the DB2 XA switch load file, run the command:-
#                nmake -f xaswiti.mak db2swit.dll
#

.SUFFIXES:

#---------------------------------------------------------------------
# DB2 XA switch file
#---------------------------------------------------------------------

.all: \
    .\db2swit.dll
    .\sybswit.dll

.\db2swit.obj: \
    db2swit.c \
    {$(INCLUDE);}xa.h
    @echo " Compile "
    icc.exe /Gm /Ti- /Gd /Ge- /Gf- /Fo".\%|fF.obj" /C db2swit.c

.\db2swit.exp: \
    .\db2swit.obj
    @echo " Make exp and lib files "
    ilib.exe /Gi:db2swit .\db2swit.obj

.\db2swit.dll: \
    .\db2swit.exp \
    .\db2swit.obj \
    {$(LIB)}db2api.lib
    @echo " Link "
    icc.exe @<<
     /B" /de /pmtype:vio /noe /code:RX /data:RW /dll"
     /B" /def"
     /B" /def:db2api"
     /B" /nod:db2swit.lib"
     /Fedb2swit.dll
     db2api.lib
     .\db2swit.exp
     .\db2swit.obj
<<
.\sybswit.obj: \
    sybswit.c \
    {$(INCLUDE);}xa.h
    @echo " Compile "
    icc.exe /Gm /Ti- /Gd /Ge- /Gf- /Fosybswit.obj /C sybswit.c

.\sybswit.exp: \
    .\sybswit.obj
    @echo " Make exp and lib files "
    ilib.exe /Gi:sybswit .\sybswit.obj

.\sybswit.dll: \
    .\sybswit.exp \
    .\sybswit.obj \
    {$(LIB)}libxaserver.lib
    @echo " Link "
    icc.exe @<<
     /B" /de /pmtype:vio /noe /code:RX /data:RW /dll"
     /B" /def"
     /B" /def:libxaserver"
     /B" /nod:sybswit.lib"
     /Fesybswit.dll
     libxaserver.lib
     .\sybswit.exp
     .\sybswit.obj
<<
